#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

enum tvdata
{
 FILE_COLUMN,
 N_COLUMNS
};

void
on_upload_list_clicked (GtkButton *button, gpointer user_data)
{
	GtkWidget* upload_dialog = create_upload_dialog();
	gtk_widget_show(upload_dialog);
	
	// Load the files into the upload list.
	GtkTreeView *upload_list_view = GTK_TREE_VIEW(lookup_widget(upload_dialog, "upload_list_view"));
	
	GtkCellRenderer *renderer;
	GtkTreeViewColumn *column;
	
	renderer = gtk_cell_renderer_text_new();
	column = gtk_tree_view_column_new_with_attributes ("Filename",
													renderer,
													"text", FILE_COLUMN,
													NULL);
	gtk_tree_view_append_column(upload_list_view, column);
	
	GtkTreeStore *store = gtk_tree_store_new (N_COLUMNS, G_TYPE_STRING);
	gtk_tree_view_set_model(upload_list_view, GTK_TREE_MODEL(store));
	
	FILE *upload_file = fopen("upload_list.txt", "r");
	if(upload_file)
	{
		while(!feof(upload_file))
		{
			GtkTreeIter iter1; /* Parent iter */
			char buf[1024];
			fgets(buf, 1023, upload_file);
			gtk_tree_store_append (store, &iter1, NULL); /* Acquire a top-level iterator */
			gtk_tree_store_set (store, &iter1, FILE_COLUMN, buf, -1);
		}
		fclose(upload_file);
	}
}


void
on_download_clicked (GtkButton *button, gpointer user_data)
{

}


void
on_send_clicked (GtkButton *button, gpointer user_data)
{

}


void
on_gtk_udp_destroy (GtkObject *object, gpointer user_data)
{

	gtk_main_quit();
}


void
on_add_upload_clicked (gpointer user_data, GtkButton *button)
{
	GtkWidget* upload_add_file = create_upload_add_file();
	gtk_widget_show(upload_add_file);
	
	GtkTreeView *upload_list_view = GTK_TREE_VIEW(user_data);
}


void
on_remove_upload_clicked (gpointer user_data, GtkButton *button)
{

}


void
on_upload_add_file_open_clicked (gpointer user_data, GtkButton *button)
{
	const gchar *filename = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(user_data));
	g_print("%s\n", filename);
	gtk_widget_destroy(GTK_WIDGET(user_data));

}

void
on_upload_add_file_cancel_clicked (gpointer user_data, GtkButton *button)
{
	gtk_widget_destroy(GTK_WIDGET(user_data));
}


void
on_upload_ok_clicked (gpointer user_data, GtkButton *button)
{
	// TODO: Save data in the list.
	gtk_widget_destroy(GTK_WIDGET(user_data));
}

void
on_upload_cancel_clicked (gpointer user_data, GtkButton *button)
{
	gtk_widget_destroy(GTK_WIDGET(user_data));
}


void
on_connect_clicked (GtkButton *button, gpointer user_data)
{
	GtkWidget *connect_dialog = create_connect_dialog();
	gtk_widget_show(connect_dialog);
}


void
on_connect_ok_clicked (gpointer user_data, GtkButton *button)
{
	// TODO: Use data to connect.
	gtk_widget_destroy(GTK_WIDGET(user_data));
}


void
on_connect_cancel_clicked (gpointer user_data, GtkButton *button)
{
	gtk_widget_destroy(GTK_WIDGET(user_data));
}



